#include <cdefbf533.h>

#define PF2_LED_CS				0x04		// SPI boot CS and LED toggle
#define SSYNC				asm ("ssync;")

section ("L1_code") 
void config_latches (void)
{
    unsigned short i=0, j=0, k;
	*pEBIU_AMBCTL0	= 0x7bb0FbF0;  
	*pEBIU_AMBCTL1	= 0x7bb07bb0;   // set timing for writing to GPIO registers on CS1 
	*pEBIU_AMGCTL	= 0x000f;

*( (volatile unsigned short *)(0x20100000) ) = 0xFF40;	// hold 1.2V core  and 1.8V rail on
k = *(volatile unsigned short *)(0x20000000);
SSYNC;

// added this to enable code without power control which should be really handling this   
*( (volatile unsigned short *)(0x20100000) ) = 0xFFD0;	// also turn on 2.8V rail and 5V and 9V
k = *(volatile unsigned short *)(0x20000000);
SSYNC;



// Set PF9 and PF10 to set lowest power state ie drive out 11 which should give 0.80V 
// initial both tristate 1.05V 
// PPF10=0 and PF9=1 gives 1.17 which is sufficient for 400MHz on BF533L parts

    *pFIO_FLAG_C    |= (PF10 | PF9);        /* value set 0.8V */

//  *pFIO_FLAG_C    |= PF10;                /* value set 1.17 */
//  *pFIO_FLAG_S    |= PF9;                 
    
    *pFIO_DIR       |= (PF10 | PF9);        /* Set core control PF pins as output */
    SSYNC;   
   
 
    
    

// enable SDRAM clock control signal to pass 

*( (volatile unsigned short *)(0x20100000) ) = 0xFBD0;	
k = *(volatile unsigned short *)(0x20000000); //dummy read
SSYNC;

// Set PF11 to enable the high order GPO pins to drive out ( this include SDRAM enable control)
    *pFIO_DIR       |= PF11;        /* Set PF11 as output */
    *pFIO_FLAG_S    |= PF11;        /* Set high */
SSYNC;




    
		//SDRAM Refresh Rate Control Register
		*pEBIU_SDRRC = 0x00000817;	
		SSYNC;

		//SDRAM Memory Bank Control Register
		//  *pEBIU_SDBCTL = 0x00000011;  //16MByte 9 bit column addr 
		//	*pEBIU_SDBCTL = 0x00000013;  //32MByte 9 bit column addr
			*pEBIU_SDBCTL = 0x00000025;  //64MByte 10 bit column addr
		
		SSYNC;

		//SDRAM Memory Global Control Register	

		*pEBIU_SDGCTL = 0x1491998d;	// mobile sdram 0x1491998d

		SSYNC;
		
		
	*pFIO_DIR |= PF2_LED_CS;	// make PF2 ann output to blink LED		
/*	while(1)
	{
		if (i==0x8000)
		{
		    j++;
			if (j==100)
			{
				*pFIO_FLAG_C = PF2_LED_CS;
				j=0;
			}
		} 
		if (i==0)
		{
		    if (j==50)
		    {
				*pFIO_FLAG_S = PF2_LED_CS;
					
		    }
		}
		i++;
	}
	
*/
}
